import 'package:osam/domain/value/base_value.dart';
import 'package:osam/osam.dart';

part 'navigation_state.g.dart';

@HiveType(typeId: 1)
class NavigationState {
  @HiveField(0)
  final BaseValue<List<String>> _routes;

  NavigationState(this._routes);

  ValueStream<List<String>> get routesStream => _routes.valueStream;

  void push(String route) => _routes.change((v) => v.add(route));

  void pushReplacement(String route) =>
      _routes.change((v) => v.replaceRange(v.length - 1, v.length, [route]));

  void pushAndRemoveUntil(String route) => _routes.change((v) => v
    ..clear()
    ..add(route));

  void pop() => _routes.change((v) => v.removeLast());
}

@HiveType(typeId: 2)
// ignore: must_be_immutable
class TabNavigationState {
  @HiveField(0)
  final BaseValue<String> tab;

  TabNavigationState(this.tab);
}
